
{$APPTYPE GUI}{$MODE DELPHI}

program demo64;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Collision;

const
  MaxStars = 900;
 
//type
  
var 
  i,l:integer;
  pos:array[0..MaxStars-1]of TGLVector;
  vel:TGLVector;
  SelMode:integer = 0;
  
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Star;
begin
  Quad(-0.3,-0.3,0, 0.3,-0.3,0, -0.3,0.3,0, 0.3,0.3,0);
end;


procedure Stars(pos:TGLVector);
begin
  LightingOFF;
  TransparentON;
  SetglSprite(false);   
  LockViewModelScaleOFF;
  LockViewModelBegin(pos.x,pos.y,pos.z);
  Star;Star;
  LockViewModelEnd;
  SetglSpriteOFF; 
  TransparentOFF;
  LightingON;   
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadTGAID('star.tga',0);
  
end;
begin 

  OpenGL_Texture();
  
  for i:=0 to MaxStars-1 do 
  pos[i]:=glvector(50-random*100,50-random*100,(150-random*300)-65);
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(300,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('N')then SelMode:=0;
  if SetglKey('B')then SelMode:=1;
  if SetglKey('S')then SelMode:=2;  
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(0,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1);   
  
  for i:=0 to MaxStars-1 do 
  begin
    case SelMode of
      0: vel.z:=0.85;
      1: vel.z:=3;
      2: vel.z:=2.75;
    end;	
	if pos[i].z>20 then vel.z:=-300;
    pos[i]:=VecAdd(pos[i],vel);
  end;
  
  TextureTGASelectID(0);
  case SelMode of
    0: for i:=0 to MaxStars-1 do Stars(pos[i]);
    1: for i:=0 to MaxStars-1 do FX_Beam(pos[i],vel,4,1,Star);
    2: for i:=0 to MaxStars-1 do FX_Streak(pos[i],8,Star);
  end;  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di FX_Beam FX_Streak - N = nprmale - B = beam - S = strak', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(300,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
